/**
 *
 * @file chameleon_d.h
 *
 * @copyright 2009-2014 The University of Tennessee and The University of
 *                      Tennessee Research Foundation. All rights reserved.
 * @copyright 2012-2021 Bordeaux INP, CNRS (LaBRI UMR 5800), Inria,
 *                      Univ. Bordeaux. All rights reserved.
 *
 ***
 *
 * @brief Chameleon CHAMELEON_double_t wrappers
 *
 * @version 1.1.0
 * @comment This file has been automatically generated
 *          from Plasma 2.5.0 for CHAMELEON 0.9.2
 * @author Jakub Kurzak
 * @author Hatem Ltaief
 * @author Azzam Haidar
 * @author Mathieu Faverge
 * @author Emmanuel Agullo
 * @author Cedric Castagnede
 * @author Florent Pruvost
 * @date 2021-03-17
 * @generated from /tmp/SBo/slackrepo.hYhfkL/build_chameleon/chameleon-1.1.0/include/chameleon/chameleon_z.h, normal z -> d, Fri Feb  2 00:25:21 2024
 *
 */
#ifndef _chameleon_d_h_
#define _chameleon_d_h_

BEGIN_C_DECLS

/**
 *  Declarations of math functions (LAPACK layout) - alphabetical order
 */
int CHAMELEON_dgeadd(cham_trans_t trans, int M, int N, double alpha, double *A, int LDA, double beta, double *B, int LDB);
//int CHAMELEON_dgebrd(int M, int N, double *A, int LDA, double *D, double *E, CHAM_desc_t *descT);
//int CHAMELEON_dgecon(cham_normtype_t norm, int N, double *A, int LDA, double anorm, double *rcond);
//int CHAMELEON_dpocon(cham_uplo_t uplo, int N, double *A, int LDA, double anorm, double *rcond);
int CHAMELEON_dgelqf(int M, int N, double *A, int LDA, CHAM_desc_t *descT);
int CHAMELEON_dgelqs(int M, int N, int NRHS, double *A, int LDA, CHAM_desc_t *descT, double *B, int LDB);
int CHAMELEON_dgels(cham_trans_t trans, int M, int N, int NRHS, double *A, int LDA, CHAM_desc_t *descT, double *B, int LDB);
double CHAMELEON_dgenm2( double tol, int M, int N, double *A, int LDA );
int CHAMELEON_dgemm(cham_trans_t transA, cham_trans_t transB, int M, int N, int K, double alpha, double *A, int LDA, double *B, int LDB, double beta, double *C, int LDC);
int CHAMELEON_dgepdf_qdwh( int M, int N, double *A, int LDA, double *H, int LDH, gepdf_info_t *info );
int CHAMELEON_dgeqrf(int M, int N, double *A, int LDA, CHAM_desc_t *descT);
int CHAMELEON_dgeqrs(int M, int N, int NRHS, double *A, int LDA, CHAM_desc_t *descT, double *B, int LDB);
//int CHAMELEON_dgesv(int N, int NRHS, double *A, int LDA, int *IPIV, double *B, int LDB);
int CHAMELEON_dgesv_incpiv(int N, int NRHS, double *A, int LDA, CHAM_desc_t *descL, int *IPIV, double *B, int LDB);
int CHAMELEON_dgesv_nopiv(int N, int NRHS, double *A, int LDA, double *B, int LDB);
int CHAMELEON_dgesvd(cham_job_t jobu, cham_job_t jobvt, int M, int N, double *A, int LDA, double *S, CHAM_desc_t *descT, double *U, int LDU, double *VT, int LDVT);
//int CHAMELEON_dgetrf(int M, int N, double *A, int LDA, int *IPIV);
int CHAMELEON_dgetrf_incpiv(int M, int N, double *A, int LDA, CHAM_desc_t *descL, int *IPIV);
int CHAMELEON_dgetrf_nopiv(int M, int N, double *A, int LDA);
//int CHAMELEON_dgetri(int N, double *A, int LDA, int *IPIV);
//int CHAMELEON_dgetrs(cham_trans_t trans, int N, int NRHS, double *A, int LDA, int *IPIV, double *B, int LDB);
int CHAMELEON_dgetrs_incpiv(cham_trans_t trans, int N, int NRHS, double *A, int LDA, CHAM_desc_t *descL, int *IPIV, double *B, int LDB);
int CHAMELEON_dgetrs_nopiv(cham_trans_t trans, int N, int NRHS, double *A, int LDA, double *B, int LDB);
int CHAMELEON_dsymm(cham_side_t side, cham_uplo_t uplo, int M, int N, double alpha, double *A, int LDA, double *B, int LDB, double beta, double *C, int LDC);
int CHAMELEON_dsyrk(cham_uplo_t uplo, cham_trans_t trans, int N, int K, double alpha, double *A, int LDA, double beta, double *C, int LDC);
int CHAMELEON_dsyr2k(cham_uplo_t uplo, cham_trans_t trans, int N, int K, double alpha, double *A, int LDA, double *B, int LDB, double beta, double *C, int LDC);
//int CHAMELEON_dsyev(cham_job_t jobz, cham_uplo_t uplo, int N, double *A, int LDA, double *W, CHAM_desc_t *descT, double *Q, int LDQ);
int CHAMELEON_dsyevd(cham_job_t jobz, cham_uplo_t uplo, int N, double *A, int LDA, double *W, CHAM_desc_t *descT);
//int CHAMELEON_dsygv(CHAMELEON_enum itype, cham_job_t jobz, cham_uplo_t uplo, int N, double *A, int LDA, double *B, int LDB, double *W, CHAM_desc_t *descT, double *Q, int LDQ);
//int CHAMELEON_dsygvd(CHAMELEON_enum itype, cham_job_t jobz, cham_uplo_t uplo, int N, double *A, int LDA, double *B, int LDB, double *W, CHAM_desc_t *descT, double *Q, int LDQ);
//int CHAMELEON_dsygst(CHAMELEON_enum itype, cham_uplo_t uplo, int N, double *A, int LDA, double *B, int LDB);
int CHAMELEON_dsytrd(cham_job_t jobz, cham_uplo_t uplo, int N, double *A, int LDA, double *D, double *E, CHAM_desc_t *descT, double *Q, int LDQ);
int CHAMELEON_dlacpy(cham_uplo_t uplo, int M, int N, double *A, int LDA, double *B, int LDB);
double CHAMELEON_dlange(cham_normtype_t norm, int M, int N, double *A, int LDA);
double CHAMELEON_dlansy(cham_normtype_t norm, cham_uplo_t uplo, int N, double *A, int LDA);
double CHAMELEON_dlansy(cham_normtype_t norm, cham_uplo_t uplo, int N, double *A, int LDA);
double CHAMELEON_dlantr(cham_normtype_t norm, cham_uplo_t uplo, cham_diag_t diag, int M, int N, double *A, int LDA);
int CHAMELEON_dlascal(cham_uplo_t uplo, int M, int N, double alpha, double *A, int LDA);
int CHAMELEON_dlaset(cham_uplo_t uplo, int M, int N, double alpha, double beta, double *A, int LDA);
//int CHAMELEON_dlaswp(int N, double *A, int LDA, int K1, int K2, int *IPIV, int INCX);
//int CHAMELEON_dlaswpc(int N, double *A, int LDA, int K1, int K2, int *IPIV, int INCX);
int CHAMELEON_dlatms( int M, int N, cham_dist_t idist, unsigned long long int seed, cham_sym_t sym, double *D, int mode, double cond, double dmax, double *A, int LDA );
int CHAMELEON_dlauum(cham_uplo_t uplo, int N, double *A, int LDA);
int CHAMELEON_dplgsy( double bump, cham_uplo_t uplo, int N, double *A, int LDA, unsigned long long int seed );
int CHAMELEON_dplgsy( double bump, cham_uplo_t uplo, int N, double *A, int LDA, unsigned long long int seed );
int CHAMELEON_dplrnt( int M, int N, double *A, int LDA, unsigned long long int seed );
int CHAMELEON_dplrnk( int M, int N, int K, double *C, int LDC, unsigned long long int seedA, unsigned long long int seedB );
int CHAMELEON_dposv(cham_uplo_t uplo, int N, int NRHS, double *A, int LDA, double *B, int LDB);
int CHAMELEON_dpotrf(cham_uplo_t uplo, int N, double *A, int LDA);
int CHAMELEON_dsytrf(cham_uplo_t uplo, int N, double *A, int LDA);
int CHAMELEON_dpotri(cham_uplo_t uplo, int N, double *A, int LDA);
int CHAMELEON_dpotrimm(cham_uplo_t uplo, int N, double *A, int LDA, double *B, int LDB, double *C, int LDC);
int CHAMELEON_dpotrs(cham_uplo_t uplo, int N, int NRHS, double *A, int LDA, double *B, int LDB);
int CHAMELEON_dsymm(cham_side_t side, cham_uplo_t uplo, int M, int N, double alpha, double *A, int LDA, double *B, int LDB, double beta, double *C, int LDC);
int CHAMELEON_dsyrk(cham_uplo_t uplo, cham_trans_t trans, int N, int K, double alpha, double *A, int LDA, double beta, double *C, int LDC);
int CHAMELEON_dsyr2k(cham_uplo_t uplo, cham_trans_t trans, int N, int K, double alpha, double *A, int LDA, double *B, int LDB, double beta, double *C, int LDC);
int CHAMELEON_dsysv(cham_uplo_t uplo, int N, int NRHS, double *A, int LDA, double *B, int LDB);
int CHAMELEON_dsytrs(cham_uplo_t uplo, int N, int NRHS, double *A, int LDA, double *B, int LDB);
int CHAMELEON_dtpgqrt( int M, int N, int K, int L, double *V1, int LDV1, CHAM_desc_t *descT1, double *V2, int LDV2, CHAM_desc_t *descT2, double *Q1, int LDQ1, double *Q2, int LDQ2 );
int CHAMELEON_dtpqrt( int M, int N, int L, double *A, int LDA, double *B, int LDB, CHAM_desc_t *descT );
int CHAMELEON_dtradd(cham_uplo_t uplo, cham_trans_t trans, int M, int N, double alpha, double *A, int LDA, double beta, double *B, int LDB);
int CHAMELEON_dtrmm(cham_side_t side, cham_uplo_t uplo, cham_trans_t transA, cham_diag_t diag, int N, int NRHS, double alpha, double *A, int LDA, double *B, int LDB);
int CHAMELEON_dtrsm(cham_side_t side, cham_uplo_t uplo, cham_trans_t transA, cham_diag_t diag, int N, int NRHS, double alpha, double *A, int LDA, double *B, int LDB);
int CHAMELEON_dtrsmpl(int N, int NRHS, double *A, int LDA, CHAM_desc_t *descL, int *IPIV, double *B, int LDB);
int CHAMELEON_dtrsmrv(cham_side_t side, cham_uplo_t uplo, cham_trans_t transA, cham_diag_t diag, int N, int NRHS, double alpha, double *A, int LDA, double *B, int LDB);
int CHAMELEON_dtrtri(cham_uplo_t uplo, cham_diag_t diag, int N, double *A, int LDA);
int CHAMELEON_dorglq(int M, int N, int K, double *A, int LDA, CHAM_desc_t *descT, double *B, int LDB);
int CHAMELEON_dorgqr(int M, int N, int K, double *A, int LDA, CHAM_desc_t *descT, double *B, int LDB);
int CHAMELEON_dormlq(cham_side_t side, cham_trans_t trans, int M, int N, int K, double *A, int LDA, CHAM_desc_t *descT, double *B, int LDB);
int CHAMELEON_dormqr(cham_side_t side, cham_trans_t trans, int M, int N, int K, double *A, int LDA, CHAM_desc_t *descT, double *B, int LDB);

//int CHAMELEON_dgecfi(int m, int n, double *A, CHAMELEON_enum fin, int imb, int inb, CHAMELEON_enum fout, int omb, int onb);
//int CHAMELEON_dgetmi(int m, int n, double *A, CHAMELEON_enum fin, int mb,  int nb);

/**
 *  Declarations of math functions (tile layout) - alphabetical order
 */
int CHAMELEON_dgeadd_Tile(cham_trans_t trans, double alpha, CHAM_desc_t *A, double beta, CHAM_desc_t *B);
//int CHAMELEON_dgebrd_Tile(CHAM_desc_t *A, double *D, double *E, CHAM_desc_t *T);
//int CHAMELEON_dgecon_Tile(cham_normtype_t norm, CHAM_desc_t *A, double anorm, double *rcond);
//int CHAMELEON_dpocon_Tile(cham_uplo_t uplo, CHAM_desc_t *A, double anorm, double *rcond);
int CHAMELEON_dgelqf_Tile(CHAM_desc_t *A, CHAM_desc_t *T);
int CHAMELEON_dgelqs_Tile(CHAM_desc_t *A, CHAM_desc_t *T, CHAM_desc_t *B);
int CHAMELEON_dgels_Tile(cham_trans_t trans, CHAM_desc_t *A, CHAM_desc_t *T, CHAM_desc_t *B);
double CHAMELEON_dgenm2_Tile( double tol, CHAM_desc_t *A );
int CHAMELEON_dgemm_Tile(cham_trans_t transA, cham_trans_t transB, double alpha, CHAM_desc_t *A, CHAM_desc_t *B, double beta, CHAM_desc_t *C);
int CHAMELEON_dgepdf_qdwh_Tile( CHAM_desc_t *A, CHAM_desc_t *H, gepdf_info_t *info );
int CHAMELEON_dgepdf_qr_Tile( int doqr, int optid, const libhqr_tree_t *qrtreeT, const libhqr_tree_t *qrtreeB, CHAM_desc_t *A1, CHAM_desc_t *TS1, CHAM_desc_t *TT1, CHAM_desc_t *Q1, CHAM_desc_t *A2, CHAM_desc_t *TS2, CHAM_desc_t *TT2, CHAM_desc_t *Q2 );
int CHAMELEON_dgeqrf_Tile(CHAM_desc_t *A, CHAM_desc_t *T);
int CHAMELEON_dgeqrs_Tile(CHAM_desc_t *A, CHAM_desc_t *T, CHAM_desc_t *B);
//int CHAMELEON_dgesv_Tile(CHAM_desc_t *A, int *IPIV, CHAM_desc_t *B);
int CHAMELEON_dgesv_incpiv_Tile(CHAM_desc_t *A, CHAM_desc_t *L, int *IPIV, CHAM_desc_t *B);
int CHAMELEON_dgesv_nopiv_Tile(CHAM_desc_t *A, CHAM_desc_t *B);
int CHAMELEON_dgesvd_Tile(cham_job_t jobu, cham_job_t jobvt, CHAM_desc_t *A, double *S, CHAM_desc_t *T, double *U, int LDU, double *VT, int LDVT);
//int CHAMELEON_dgetrf_Tile(CHAM_desc_t *A, int *IPIV);
int CHAMELEON_dgetrf_incpiv_Tile(CHAM_desc_t *A, CHAM_desc_t *L, int *IPIV);
int CHAMELEON_dgetrf_nopiv_Tile(CHAM_desc_t *A);
//int CHAMELEON_dgetri_Tile(CHAM_desc_t *A, int *IPIV);
//int CHAMELEON_dgetrs_Tile(cham_trans_t trans, CHAM_desc_t *A, int *IPIV, CHAM_desc_t *B);
int CHAMELEON_dgetrs_incpiv_Tile(CHAM_desc_t *A, CHAM_desc_t *L, int *IPIV, CHAM_desc_t *B);
int CHAMELEON_dgetrs_nopiv_Tile(CHAM_desc_t *A, CHAM_desc_t *B);
int CHAMELEON_dsymm_Tile(cham_side_t side, cham_uplo_t uplo, double alpha, CHAM_desc_t *A, CHAM_desc_t *B, double beta, CHAM_desc_t *C);
int CHAMELEON_dsyrk_Tile(cham_uplo_t uplo, cham_trans_t trans, double alpha, CHAM_desc_t *A, double beta, CHAM_desc_t *C);
int CHAMELEON_dsyr2k_Tile(cham_uplo_t uplo, cham_trans_t trans, double alpha, CHAM_desc_t *A, CHAM_desc_t *B, double beta, CHAM_desc_t *C);
//int CHAMELEON_dsyev_Tile(cham_job_t jobz, cham_uplo_t uplo, CHAM_desc_t *A, double *W, CHAM_desc_t *T, double *Q, int LDQ);
int CHAMELEON_dsyevd_Tile(cham_job_t jobz, cham_uplo_t uplo, CHAM_desc_t *A, double *W, CHAM_desc_t *T);
//int CHAMELEON_dsygv_Tile( CHAMELEON_enum itype, cham_job_t jobz, cham_uplo_t uplo, CHAM_desc_t *A, CHAM_desc_t *B, double *W, CHAM_desc_t *T, CHAM_desc_t *Q);
//int CHAMELEON_dsygvd_Tile(CHAMELEON_enum itype, cham_job_t jobz, cham_uplo_t uplo, CHAM_desc_t *A, CHAM_desc_t *B, double *W, CHAM_desc_t *T, CHAM_desc_t *Q);
//int CHAMELEON_dsygst_Tile(CHAMELEON_enum itype, cham_uplo_t uplo, CHAM_desc_t *A, CHAM_desc_t *B);
int CHAMELEON_dsytrd_Tile(cham_job_t jobz, cham_uplo_t uplo, CHAM_desc_t *A, double *D, double *E, CHAM_desc_t *T, double *Q, int LDQ);
int CHAMELEON_dlacpy_Tile(cham_uplo_t uplo, CHAM_desc_t *A, CHAM_desc_t *B);
double CHAMELEON_dlange_Tile(cham_normtype_t norm, CHAM_desc_t *A);
double CHAMELEON_dlansy_Tile(cham_normtype_t norm, cham_uplo_t uplo, CHAM_desc_t *A);
double CHAMELEON_dlansy_Tile(cham_normtype_t norm, cham_uplo_t uplo, CHAM_desc_t *A);
double CHAMELEON_dlantr_Tile(cham_normtype_t norm, cham_uplo_t uplo, cham_diag_t diag, CHAM_desc_t *A);
int CHAMELEON_dlascal_Tile(cham_uplo_t uplo, double alpha, CHAM_desc_t *A);
int CHAMELEON_dlaset_Tile(cham_uplo_t uplo, double alpha, double beta, CHAM_desc_t *A);
//int CHAMELEON_dlaswp_Tile(CHAM_desc_t *A, int K1, int K2, int *IPIV, int INCX);
//int CHAMELEON_dlaswpc_Tile(CHAM_desc_t *A, int K1, int K2, int *IPIV, int INCX);
int CHAMELEON_dlatms_Tile( cham_dist_t idist, unsigned long long int seed, cham_sym_t sym, double *D, int mode, double cond, double dmax, CHAM_desc_t *A );
int CHAMELEON_dlauum_Tile(cham_uplo_t uplo, CHAM_desc_t *A);
int CHAMELEON_dplgsy_Tile(double bump, cham_uplo_t uplo, CHAM_desc_t *A, unsigned long long int seed );
int CHAMELEON_dplgsy_Tile(double bump, cham_uplo_t uplo, CHAM_desc_t *A, unsigned long long int seed );
int CHAMELEON_dplrnt_Tile(CHAM_desc_t *A, unsigned long long int seed );
int CHAMELEON_dplrnk_Tile(int K, CHAM_desc_t *C, unsigned long long int seedA, unsigned long long int seedB );
int CHAMELEON_dposv_Tile(cham_uplo_t uplo, CHAM_desc_t *A, CHAM_desc_t *B);
int CHAMELEON_dpotrf_Tile(cham_uplo_t uplo, CHAM_desc_t *A);
int CHAMELEON_dsytrf_Tile(cham_uplo_t uplo, CHAM_desc_t *A);
int CHAMELEON_dpotri_Tile(cham_uplo_t uplo, CHAM_desc_t *A);
int CHAMELEON_dpotrimm_Tile(cham_uplo_t uplo, CHAM_desc_t *A, CHAM_desc_t *B, CHAM_desc_t *C);
int CHAMELEON_dpotrs_Tile(cham_uplo_t uplo, CHAM_desc_t *A, CHAM_desc_t *B);
int CHAMELEON_dsymm_Tile(cham_side_t side, cham_uplo_t uplo, double alpha, CHAM_desc_t *A, CHAM_desc_t *B, double beta, CHAM_desc_t *C);
int CHAMELEON_dsyrk_Tile(cham_uplo_t uplo, cham_trans_t trans, double alpha, CHAM_desc_t *A, double beta, CHAM_desc_t *C);
int CHAMELEON_dsyr2k_Tile(cham_uplo_t uplo, cham_trans_t trans, double alpha, CHAM_desc_t *A, CHAM_desc_t *B, double beta, CHAM_desc_t *C);
int CHAMELEON_dsysv_Tile(cham_uplo_t uplo, CHAM_desc_t *A, CHAM_desc_t *B);
int CHAMELEON_dsytrs_Tile(cham_uplo_t uplo, CHAM_desc_t *A, CHAM_desc_t *B);
int CHAMELEON_dtpgqrt_Tile( int L, CHAM_desc_t *V1, CHAM_desc_t *T1, CHAM_desc_t *V2, CHAM_desc_t *T2, CHAM_desc_t *Q1, CHAM_desc_t *Q2 );
int CHAMELEON_dtpqrt_Tile( int L, CHAM_desc_t *A, CHAM_desc_t *B, CHAM_desc_t *T );
int CHAMELEON_dtradd_Tile(cham_uplo_t uplo, cham_trans_t trans, double alpha, CHAM_desc_t *A, double beta, CHAM_desc_t *B);
int CHAMELEON_dtrmm_Tile(cham_side_t side, cham_uplo_t uplo, cham_trans_t transA, cham_diag_t diag, double alpha, CHAM_desc_t *A, CHAM_desc_t *B);
int CHAMELEON_dtrsm_Tile(cham_side_t side, cham_uplo_t uplo, cham_trans_t transA, cham_diag_t diag, double alpha, CHAM_desc_t *A, CHAM_desc_t *B);
int CHAMELEON_dtrsmpl_Tile(CHAM_desc_t *A, CHAM_desc_t *L, int *IPIV, CHAM_desc_t *B);
int CHAMELEON_dtrsmrv_Tile(cham_side_t side, cham_uplo_t uplo, cham_trans_t transA, cham_diag_t diag, double alpha, CHAM_desc_t *A, CHAM_desc_t *B);
int CHAMELEON_dtrtri_Tile(cham_uplo_t uplo, cham_diag_t diag, CHAM_desc_t *A);
int CHAMELEON_dorglq_Tile(CHAM_desc_t *A, CHAM_desc_t *T, CHAM_desc_t *B);
int CHAMELEON_dorgqr_Tile(CHAM_desc_t *A, CHAM_desc_t *T, CHAM_desc_t *B);
int CHAMELEON_dormlq_Tile(cham_side_t side, cham_trans_t trans, CHAM_desc_t *A, CHAM_desc_t *T, CHAM_desc_t *B);
int CHAMELEON_dormqr_Tile(cham_side_t side, cham_trans_t trans, CHAM_desc_t *A, CHAM_desc_t *T, CHAM_desc_t *B);

/**
 *  Declarations of math functions (tile layout, asynchronous execution) - alphabetical order
 */
int CHAMELEON_dgeadd_Tile_Async(cham_trans_t trans, double alpha, CHAM_desc_t *A, double beta, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
//int CHAMELEON_dgebrd_Tile_Async(CHAM_desc_t *A, double *D, double *E, CHAM_desc_t *T, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
//int CHAMELEON_dgecon_Tile_Async(cham_normtype_t norm, CHAM_desc_t *A, double anorm, double *rcond, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
//int CHAMELEON_dpocon_Tile_Async(cham_uplo_t uplo, CHAM_desc_t *A, double anorm, double *rcond, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_dgelqf_Tile_Async(CHAM_desc_t *A, CHAM_desc_t *T, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_dgelqs_Tile_Async(CHAM_desc_t *A, CHAM_desc_t *T, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_dgels_Tile_Async(cham_trans_t trans, CHAM_desc_t *A, CHAM_desc_t *T, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_dgenm2_Tile_Async( double tol, CHAM_desc_t *A, double *value, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request );
int CHAMELEON_dgemm_Tile_Async(cham_trans_t transA, cham_trans_t transB, double alpha, CHAM_desc_t *A, CHAM_desc_t *B, double beta, CHAM_desc_t *C, void *ws, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_dgepdf_qdwh_Tile_Async( CHAM_desc_t *A, CHAM_desc_t *H, gepdf_info_t *info, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request );
int CHAMELEON_dgeqrf_Tile_Async(CHAM_desc_t *A, CHAM_desc_t *T, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_dgeqrs_Tile_Async(CHAM_desc_t *A, CHAM_desc_t *T, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
//int CHAMELEON_dgesv_Tile_Async(CHAM_desc_t *A, int *IPIV, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_dgesv_incpiv_Tile_Async(CHAM_desc_t *A, CHAM_desc_t *L, int *IPIV, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_dgesv_nopiv_Tile_Async(CHAM_desc_t *A, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_dgesvd_Tile_Async(cham_job_t jobu, cham_job_t jobvt, CHAM_desc_t *A, double *S, CHAM_desc_t *T, double *U, int LDU, double *VT, int LDVT, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
//int CHAMELEON_dgetrf_Tile_Async(CHAM_desc_t *A, int *IPIV, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_dgetrf_incpiv_Tile_Async(CHAM_desc_t *A, CHAM_desc_t *L, int *IPIV, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_dgetrf_nopiv_Tile_Async(CHAM_desc_t *A, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
//int CHAMELEON_dgetri_Tile_Async(CHAM_desc_t *A, int *IPIV, CHAM_desc_t *W, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
//int CHAMELEON_dgetrs_Tile_Async(cham_trans_t trans, CHAM_desc_t *A, int *IPIV, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_dgetrs_incpiv_Tile_Async(CHAM_desc_t *A, CHAM_desc_t *L, int *IPIV, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_dgetrs_nopiv_Tile_Async(CHAM_desc_t *A, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_dsymm_Tile_Async(cham_side_t side, cham_uplo_t uplo, double alpha, CHAM_desc_t *A, CHAM_desc_t *B, double beta, CHAM_desc_t *C, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_dsyrk_Tile_Async(cham_uplo_t uplo, cham_trans_t trans, double alpha, CHAM_desc_t *A, double beta, CHAM_desc_t *C, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_dsyr2k_Tile_Async(cham_uplo_t uplo, cham_trans_t trans, double alpha, CHAM_desc_t *A, CHAM_desc_t *B, double beta, CHAM_desc_t *C, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
//int CHAMELEON_dsyev_Tile_Async(cham_job_t jobz, cham_uplo_t uplo, CHAM_desc_t *A, double *W, CHAM_desc_t *T, double *Q, int LDQ, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_dsyevd_Tile_Async(cham_job_t jobz, cham_uplo_t uplo, CHAM_desc_t *A, double *W, CHAM_desc_t *T, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
//int CHAMELEON_dsygv_Tile_Async( CHAMELEON_enum itype, cham_job_t jobz, cham_uplo_t uplo, CHAM_desc_t *A, CHAM_desc_t *B, double *W, CHAM_desc_t *T, CHAM_desc_t *Q, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
//int CHAMELEON_dsygvd_Tile_Async(CHAMELEON_enum itype, cham_job_t jobz, cham_uplo_t uplo, CHAM_desc_t *A, CHAM_desc_t *B, double *W, CHAM_desc_t *T, CHAM_desc_t *Q, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
//int CHAMELEON_dsygst_Tile_Async(CHAMELEON_enum itype, cham_uplo_t uplo, CHAM_desc_t *A, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_dsytrd_Tile_Async(cham_job_t jobz, cham_uplo_t uplo, CHAM_desc_t *A, double *D, double *E, CHAM_desc_t *T, double *Q, int LDQ, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_dlacpy_Tile_Async(cham_uplo_t uplo, CHAM_desc_t *A, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_dlange_Tile_Async(cham_normtype_t norm, CHAM_desc_t *A, double *value, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_dlansy_Tile_Async(cham_normtype_t norm, cham_uplo_t uplo, CHAM_desc_t *A, double *value, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_dlansy_Tile_Async(cham_normtype_t norm, cham_uplo_t uplo, CHAM_desc_t *A, double *value, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_dlantr_Tile_Async(cham_normtype_t norm, cham_uplo_t uplo, cham_diag_t diag, CHAM_desc_t *A, double *value, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_dlascal_Tile_Async(cham_uplo_t uplo, double alpha, CHAM_desc_t *A, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_dlaset_Tile_Async(cham_uplo_t uplo, double alpha, double beta, CHAM_desc_t *A, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
//int CHAMELEON_dlaswp_Tile_Async(CHAM_desc_t *A, int K1, int K2, int *IPIV, int INCX, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
//int CHAMELEON_dlaswpc_Tile_Async(CHAM_desc_t *A, int K1, int K2, int *IPIV, int INCX, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_dlatms_Tile_Async( cham_dist_t idist, unsigned long long int seed, cham_sym_t sym, double *D, int mode, double cond, double dmax, CHAM_desc_t *A, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request );
int CHAMELEON_dlauum_Tile_Async(cham_uplo_t uplo, CHAM_desc_t *A, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_dplgsy_Tile_Async(double bump, cham_uplo_t uplo, CHAM_desc_t *A, unsigned long long int seed, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request );
int CHAMELEON_dplgsy_Tile_Async(double bump, cham_uplo_t uplo, CHAM_desc_t *A, unsigned long long int seed, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request );
int CHAMELEON_dplrnt_Tile_Async(CHAM_desc_t *A, unsigned long long int seed, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request );
int CHAMELEON_dplrnk_Tile_Async(int K, CHAM_desc_t *C, unsigned long long int seedA, unsigned long long int seedB, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request );
int CHAMELEON_dposv_Tile_Async(cham_uplo_t uplo, CHAM_desc_t *A, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_dpotrf_Tile_Async(cham_uplo_t uplo, CHAM_desc_t *A, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_dsytrf_Tile_Async(cham_uplo_t uplo, CHAM_desc_t *A, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_dpotri_Tile_Async(cham_uplo_t uplo, CHAM_desc_t *A, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_dpotrimm_Tile_Async(cham_uplo_t uplo, CHAM_desc_t *A, CHAM_desc_t *B, CHAM_desc_t *C, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_dpotrs_Tile_Async(cham_uplo_t uplo, CHAM_desc_t *A, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_dsysv_Tile_Async(cham_uplo_t uplo, CHAM_desc_t *A, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_dsytrs_Tile_Async(cham_uplo_t uplo, CHAM_desc_t *A, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_dsymm_Tile_Async(cham_side_t side, cham_uplo_t uplo, double alpha, CHAM_desc_t *A, CHAM_desc_t *B, double beta, CHAM_desc_t *C, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_dsyrk_Tile_Async(cham_uplo_t uplo, cham_trans_t trans, double alpha, CHAM_desc_t *A, double beta, CHAM_desc_t *C, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_dsyr2k_Tile_Async(cham_uplo_t uplo, cham_trans_t trans, double alpha, CHAM_desc_t *A, CHAM_desc_t *B, double beta, CHAM_desc_t *C, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_dtpgqrt_Tile_Async( int L, CHAM_desc_t *V1, CHAM_desc_t *T1, CHAM_desc_t *V2, CHAM_desc_t *T2, CHAM_desc_t *Q1, CHAM_desc_t *Q2, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request );
int CHAMELEON_dtpqrt_Tile_Async( int L, CHAM_desc_t *A, CHAM_desc_t *B, CHAM_desc_t *T, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request );
int CHAMELEON_dtradd_Tile_Async(cham_uplo_t uplo, cham_trans_t trans, double alpha, CHAM_desc_t *A, double beta, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_dtrmm_Tile_Async(cham_side_t side, cham_uplo_t uplo, cham_trans_t transA, cham_diag_t diag, double alpha, CHAM_desc_t *A, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_dtrsm_Tile_Async(cham_side_t side, cham_uplo_t uplo, cham_trans_t transA, cham_diag_t diag, double alpha, CHAM_desc_t *A, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_dtrsmpl_Tile_Async(CHAM_desc_t *A, CHAM_desc_t *L, int *IPIV, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_dtrsmrv_Tile_Async(cham_side_t side, cham_uplo_t uplo, cham_trans_t transA, cham_diag_t diag, double alpha, CHAM_desc_t *A, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_dtrtri_Tile_Async(cham_uplo_t uplo, cham_diag_t diag, CHAM_desc_t *A, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_dorglq_Tile_Async(CHAM_desc_t *A, CHAM_desc_t *T, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_dorgqr_Tile_Async(CHAM_desc_t *A, CHAM_desc_t *T, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_dormlq_Tile_Async(cham_side_t side, cham_trans_t trans, CHAM_desc_t *A, CHAM_desc_t *T, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_dormqr_Tile_Async(cham_side_t side, cham_trans_t trans, CHAM_desc_t *A, CHAM_desc_t *T, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);

//int CHAMELEON_dgecfi_Async(int m, int n, double *A, CHAMELEON_enum f_in, int imb, int inb, CHAMELEON_enum f_out, int omb, int onb, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
//int CHAMELEON_dgetmi_Async(int m, int n, double *A, CHAMELEON_enum f_in, int mb,  int inb, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);

/**
 *  Declarations of libhqr dependent functions.
 */
/**
 *  Declarations of math functions (LAPACK layout) - alphabetical order
 */
int CHAMELEON_dgels_param(const libhqr_tree_t *qrtree, cham_trans_t trans, int M, int N, int NRHS, double *A, int LDA, CHAM_desc_t *descTS, CHAM_desc_t *descTT, double *B, int LDB);
int CHAMELEON_dgelqf_param(const libhqr_tree_t *qrtree, int M, int N, double *A, int LDA, CHAM_desc_t *descTS, CHAM_desc_t *descTT);
int CHAMELEON_dgelqs_param(const libhqr_tree_t *qrtree, int M, int N, int NRHS, double *A, int LDA, CHAM_desc_t *descTS, CHAM_desc_t *descTT, double *B, int LDB);
int CHAMELEON_dgeqrf_param(const libhqr_tree_t *qrtree, int M, int N, double *A, int LDA, CHAM_desc_t *descTS, CHAM_desc_t *descTT);
int CHAMELEON_dgeqrs_param(const libhqr_tree_t *qrtree, int M, int N, int NRHS, double *A, int LDA, CHAM_desc_t *descTS, CHAM_desc_t *TT, double *B, int LDB);
int CHAMELEON_dorglq_param(const libhqr_tree_t *qrtree, int M, int N, int K, double *A, int LDA, CHAM_desc_t *descTS, CHAM_desc_t *TT, double *B, int LDB);
int CHAMELEON_dorgqr_param(const libhqr_tree_t *qrtree, int M, int N, int K, double *A, int LDA, CHAM_desc_t *descTS, CHAM_desc_t *descTT, double *B, int LDB);
int CHAMELEON_dormlq_param(const libhqr_tree_t *qrtree, cham_side_t side, cham_trans_t trans, int M, int N, int K, double *A, int LDA, CHAM_desc_t *descT, CHAM_desc_t *TT, double *B, int LDB);
int CHAMELEON_dormlq_param(const libhqr_tree_t *qrtree, cham_side_t side, cham_trans_t trans, int M, int N, int K, double *A, int LDA, CHAM_desc_t *descT, CHAM_desc_t *TT, double *B, int LDB);
int CHAMELEON_dormqr_param(const libhqr_tree_t *qrtree, cham_side_t side, cham_trans_t trans, int M, int N, int K, double *A, int LDA, CHAM_desc_t *descTS, CHAM_desc_t *TT, double *B, int LDB);
/**
 *  Declarations of math functions (tile layout) - alphabetical order
 */
int CHAMELEON_dgels_param_Tile(const libhqr_tree_t *qrtree, cham_trans_t trans, CHAM_desc_t *A, CHAM_desc_t *TS, CHAM_desc_t *TT, CHAM_desc_t *B);
int CHAMELEON_dgelqf_param_Tile(const libhqr_tree_t *qrtree, CHAM_desc_t *A, CHAM_desc_t *TS, CHAM_desc_t *TT);
int CHAMELEON_dgelqs_param_Tile(const libhqr_tree_t *qrtree, CHAM_desc_t *A, CHAM_desc_t *TS, CHAM_desc_t *TT, CHAM_desc_t *B);
int CHAMELEON_dgeqrf_param_Tile(const libhqr_tree_t *qrtree, CHAM_desc_t *A, CHAM_desc_t *TS, CHAM_desc_t *TT);
int CHAMELEON_dgeqrs_param_Tile(const libhqr_tree_t *qrtree, CHAM_desc_t *A, CHAM_desc_t *TS, CHAM_desc_t *TT, CHAM_desc_t *B);
int CHAMELEON_dorglq_param_Tile(const libhqr_tree_t *qrtree, CHAM_desc_t *A, CHAM_desc_t *TS, CHAM_desc_t *TT, CHAM_desc_t *B);
int CHAMELEON_dorgqr_param_Tile(const libhqr_tree_t *qrtree, CHAM_desc_t *A, CHAM_desc_t *TS, CHAM_desc_t *TT, CHAM_desc_t *B);
int CHAMELEON_dorgqr_param_Tile(const libhqr_tree_t *qrtree, CHAM_desc_t *A, CHAM_desc_t *TS, CHAM_desc_t *TT, CHAM_desc_t *B);
int CHAMELEON_dormlq_param_Tile(const libhqr_tree_t *qrtree, cham_side_t side, cham_trans_t trans, CHAM_desc_t *A, CHAM_desc_t *TS, CHAM_desc_t *TT, CHAM_desc_t *B);
int CHAMELEON_dormqr_param_Tile(const libhqr_tree_t *qrtree, cham_side_t side, cham_trans_t trans, CHAM_desc_t *A, CHAM_desc_t *TS, CHAM_desc_t *TT, CHAM_desc_t *B);
/**
 *  Declarations of math functions (tile layout, asynchronous execution) - alphabetical order
 */
int CHAMELEON_dgels_param_Tile_Async(const libhqr_tree_t *qrtree, cham_trans_t trans, CHAM_desc_t *A, CHAM_desc_t *TS, CHAM_desc_t *TT, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_dgelqf_param_Tile_Async(const libhqr_tree_t *qrtree, CHAM_desc_t *A, CHAM_desc_t *TS, CHAM_desc_t *TT, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_dgelqs_param_Tile_Async(const libhqr_tree_t *qrtree, CHAM_desc_t *A, CHAM_desc_t *TS, CHAM_desc_t *TT, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_dgeqrf_param_Tile_Async(const libhqr_tree_t *qrtree, CHAM_desc_t *A, CHAM_desc_t *TS, CHAM_desc_t *TT, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_dgeqrs_param_Tile_Async(const libhqr_tree_t *qrtree, CHAM_desc_t *A, CHAM_desc_t *TS, CHAM_desc_t *TT, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_dorglq_param_Tile_Async(const libhqr_tree_t *qrtree, CHAM_desc_t *A, CHAM_desc_t *TS, CHAM_desc_t *TT, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_dorgqr_param_Tile_Async(const libhqr_tree_t *qrtree, CHAM_desc_t *A, CHAM_desc_t *TS, CHAM_desc_t *TT, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_dormlq_param_Tile_Async(const libhqr_tree_t *qrtree, cham_side_t side, cham_trans_t trans, CHAM_desc_t *A, CHAM_desc_t *TS, CHAM_desc_t *TT, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_dormqr_param_Tile_Async(const libhqr_tree_t *qrtree, cham_side_t side, cham_trans_t trans, CHAM_desc_t *A, CHAM_desc_t *TS, CHAM_desc_t *TT, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);

/**
 *  Declarations of workspace allocation functions (tile layout) - alphabetical order
 */
void *CHAMELEON_dgemm_WS_Alloc( cham_trans_t transA, cham_trans_t transB, const CHAM_desc_t *A, const CHAM_desc_t *B, const CHAM_desc_t *C );
void  CHAMELEON_dgemm_WS_Free( void *ws );
void *CHAMELEON_dgram_WS_Alloc( const CHAM_desc_t *A );
void  CHAMELEON_dgram_WS_Free( void *ws );

int CHAMELEON_Alloc_Workspace_dgesv_incpiv(        int N, CHAM_desc_t **descL, int **IPIV, int p, int q);
int CHAMELEON_Alloc_Workspace_dgetrf_incpiv(int M, int N, CHAM_desc_t **descL, int **IPIV, int p, int q);

int CHAMELEON_Alloc_Workspace_dgebrd(int M, int N, CHAM_desc_t **descT, int p, int q);
int CHAMELEON_Alloc_Workspace_dgeev( int N,        CHAM_desc_t **descT, int p, int q);
int CHAMELEON_Alloc_Workspace_dgehrd(int N,        CHAM_desc_t **descT, int p, int q);
int CHAMELEON_Alloc_Workspace_dgelqf(int M, int N, CHAM_desc_t **T, int p, int q);
int CHAMELEON_Alloc_Workspace_dgels( int M, int N, CHAM_desc_t **T, int p, int q);
int CHAMELEON_Alloc_Workspace_dgeqrf(int M, int N, CHAM_desc_t **T, int p, int q);
int CHAMELEON_Alloc_Workspace_dgesvd(int M, int N, CHAM_desc_t **descT, int p, int q);
int CHAMELEON_Alloc_Workspace_dsyev( int M, int N, CHAM_desc_t **descT, int p, int q);
int CHAMELEON_Alloc_Workspace_dsyevd( int M, int N, CHAM_desc_t **descT, int p, int q);
int CHAMELEON_Alloc_Workspace_dsygv( int M, int N, CHAM_desc_t **descT, int p, int q);
int CHAMELEON_Alloc_Workspace_dsygvd( int M, int N, CHAM_desc_t **descT, int p, int q);
int CHAMELEON_Alloc_Workspace_dsytrd(int M, int N, CHAM_desc_t **descT, int p, int q);

/**
 *  Declarations of workspace allocation functions (tile layout, asynchronous execution) - alphabetical order
 */
int CHAMELEON_Alloc_Workspace_dgetri_Tile_Async(CHAM_desc_t *A, CHAM_desc_t *W);

/* Warning: Those functions are deprecated */
int CHAMELEON_Alloc_Workspace_dgelqf_Tile(int M, int N, CHAM_desc_t **descT, int p, int q);
int CHAMELEON_Alloc_Workspace_dgels_Tile( int M, int N, CHAM_desc_t **descT, int p, int q);
int CHAMELEON_Alloc_Workspace_dgeqrf_Tile(int M, int N, CHAM_desc_t **descT, int p, int q);
int CHAMELEON_Alloc_Workspace_dgesv_incpiv_Tile (int N, CHAM_desc_t **descL, int **IPIV, int p, int q);
int CHAMELEON_Alloc_Workspace_dgetrf_incpiv_Tile(int N, CHAM_desc_t **descL, int **IPIV, int p, int q);

/**
 *  Auxiliary function prototypes
 */
int CHAMELEON_dLapack_to_Tile( double *Af77, int LDA, CHAM_desc_t *A ) __attribute__((deprecated("Please refer to CHAMELEON_dLap2Desc() instead")));
int CHAMELEON_dTile_to_Lapack( CHAM_desc_t *A, double *Af77, int LDA ) __attribute__((deprecated("Please refer to CHAMELEON_dDesc2Lap() instead")));
int CHAMELEON_dLap2Desc( cham_uplo_t uplo, double *Af77, int LDA, CHAM_desc_t *A );
int CHAMELEON_dDesc2Lap( cham_uplo_t uplo, CHAM_desc_t *A, double *Af77, int LDA );

/**
 *  User Builder function prototypes
 */
int CHAMELEON_dbuild(cham_uplo_t uplo, int M, int N, double *A, int LDA, void *user_data, void* user_build_callback);
int CHAMELEON_dbuild_Tile(cham_uplo_t uplo,  CHAM_desc_t *A, void *user_data, void* user_build_callback );
int CHAMELEON_dbuild_Tile_Async(cham_uplo_t uplo, CHAM_desc_t *A, void *user_data, void* user_build_callback, RUNTIME_sequence_t *sequence, RUNTIME_request_t  *request);

/**
 * Gram function prototypes
 */
int CHAMELEON_dgram( cham_uplo_t uplo, int N, double *A, int LDA );
int CHAMELEON_dgram_Tile( cham_uplo_t uplo, CHAM_desc_t *A );
int CHAMELEON_dgram_Tile_Async( cham_uplo_t uplo, CHAM_desc_t *A, void *user_ws, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request );

END_C_DECLS

#endif /* _chameleon_d_h_ */
