/**
 *
 * @file chameleon_s.h
 *
 * @copyright 2009-2014 The University of Tennessee and The University of
 *                      Tennessee Research Foundation. All rights reserved.
 * @copyright 2012-2021 Bordeaux INP, CNRS (LaBRI UMR 5800), Inria,
 *                      Univ. Bordeaux. All rights reserved.
 *
 ***
 *
 * @brief Chameleon CHAMELEON_float_t wrappers
 *
 * @version 1.1.0
 * @comment This file has been automatically generated
 *          from Plasma 2.5.0 for CHAMELEON 0.9.2
 * @author Jakub Kurzak
 * @author Hatem Ltaief
 * @author Azzam Haidar
 * @author Mathieu Faverge
 * @author Emmanuel Agullo
 * @author Cedric Castagnede
 * @author Florent Pruvost
 * @date 2021-03-17
 * @generated from /tmp/SBo/slackrepo.hYhfkL/build_chameleon/chameleon-1.1.0/include/chameleon/chameleon_z.h, normal z -> s, Fri Feb  2 00:25:22 2024
 *
 */
#ifndef _chameleon_s_h_
#define _chameleon_s_h_

BEGIN_C_DECLS

/**
 *  Declarations of math functions (LAPACK layout) - alphabetical order
 */
int CHAMELEON_sgeadd(cham_trans_t trans, int M, int N, float alpha, float *A, int LDA, float beta, float *B, int LDB);
//int CHAMELEON_sgebrd(int M, int N, float *A, int LDA, float *D, float *E, CHAM_desc_t *descT);
//int CHAMELEON_sgecon(cham_normtype_t norm, int N, float *A, int LDA, float anorm, float *rcond);
//int CHAMELEON_spocon(cham_uplo_t uplo, int N, float *A, int LDA, float anorm, float *rcond);
int CHAMELEON_sgelqf(int M, int N, float *A, int LDA, CHAM_desc_t *descT);
int CHAMELEON_sgelqs(int M, int N, int NRHS, float *A, int LDA, CHAM_desc_t *descT, float *B, int LDB);
int CHAMELEON_sgels(cham_trans_t trans, int M, int N, int NRHS, float *A, int LDA, CHAM_desc_t *descT, float *B, int LDB);
float CHAMELEON_sgenm2( float tol, int M, int N, float *A, int LDA );
int CHAMELEON_sgemm(cham_trans_t transA, cham_trans_t transB, int M, int N, int K, float alpha, float *A, int LDA, float *B, int LDB, float beta, float *C, int LDC);
int CHAMELEON_sgepdf_qdwh( int M, int N, float *A, int LDA, float *H, int LDH, gepdf_info_t *info );
int CHAMELEON_sgeqrf(int M, int N, float *A, int LDA, CHAM_desc_t *descT);
int CHAMELEON_sgeqrs(int M, int N, int NRHS, float *A, int LDA, CHAM_desc_t *descT, float *B, int LDB);
//int CHAMELEON_sgesv(int N, int NRHS, float *A, int LDA, int *IPIV, float *B, int LDB);
int CHAMELEON_sgesv_incpiv(int N, int NRHS, float *A, int LDA, CHAM_desc_t *descL, int *IPIV, float *B, int LDB);
int CHAMELEON_sgesv_nopiv(int N, int NRHS, float *A, int LDA, float *B, int LDB);
int CHAMELEON_sgesvd(cham_job_t jobu, cham_job_t jobvt, int M, int N, float *A, int LDA, float *S, CHAM_desc_t *descT, float *U, int LDU, float *VT, int LDVT);
//int CHAMELEON_sgetrf(int M, int N, float *A, int LDA, int *IPIV);
int CHAMELEON_sgetrf_incpiv(int M, int N, float *A, int LDA, CHAM_desc_t *descL, int *IPIV);
int CHAMELEON_sgetrf_nopiv(int M, int N, float *A, int LDA);
//int CHAMELEON_sgetri(int N, float *A, int LDA, int *IPIV);
//int CHAMELEON_sgetrs(cham_trans_t trans, int N, int NRHS, float *A, int LDA, int *IPIV, float *B, int LDB);
int CHAMELEON_sgetrs_incpiv(cham_trans_t trans, int N, int NRHS, float *A, int LDA, CHAM_desc_t *descL, int *IPIV, float *B, int LDB);
int CHAMELEON_sgetrs_nopiv(cham_trans_t trans, int N, int NRHS, float *A, int LDA, float *B, int LDB);
int CHAMELEON_ssymm(cham_side_t side, cham_uplo_t uplo, int M, int N, float alpha, float *A, int LDA, float *B, int LDB, float beta, float *C, int LDC);
int CHAMELEON_ssyrk(cham_uplo_t uplo, cham_trans_t trans, int N, int K, float alpha, float *A, int LDA, float beta, float *C, int LDC);
int CHAMELEON_ssyr2k(cham_uplo_t uplo, cham_trans_t trans, int N, int K, float alpha, float *A, int LDA, float *B, int LDB, float beta, float *C, int LDC);
//int CHAMELEON_ssyev(cham_job_t jobz, cham_uplo_t uplo, int N, float *A, int LDA, float *W, CHAM_desc_t *descT, float *Q, int LDQ);
int CHAMELEON_ssyevd(cham_job_t jobz, cham_uplo_t uplo, int N, float *A, int LDA, float *W, CHAM_desc_t *descT);
//int CHAMELEON_ssygv(CHAMELEON_enum itype, cham_job_t jobz, cham_uplo_t uplo, int N, float *A, int LDA, float *B, int LDB, float *W, CHAM_desc_t *descT, float *Q, int LDQ);
//int CHAMELEON_ssygvd(CHAMELEON_enum itype, cham_job_t jobz, cham_uplo_t uplo, int N, float *A, int LDA, float *B, int LDB, float *W, CHAM_desc_t *descT, float *Q, int LDQ);
//int CHAMELEON_ssygst(CHAMELEON_enum itype, cham_uplo_t uplo, int N, float *A, int LDA, float *B, int LDB);
int CHAMELEON_ssytrd(cham_job_t jobz, cham_uplo_t uplo, int N, float *A, int LDA, float *D, float *E, CHAM_desc_t *descT, float *Q, int LDQ);
int CHAMELEON_slacpy(cham_uplo_t uplo, int M, int N, float *A, int LDA, float *B, int LDB);
float CHAMELEON_slange(cham_normtype_t norm, int M, int N, float *A, int LDA);
float CHAMELEON_slansy(cham_normtype_t norm, cham_uplo_t uplo, int N, float *A, int LDA);
float CHAMELEON_slansy(cham_normtype_t norm, cham_uplo_t uplo, int N, float *A, int LDA);
float CHAMELEON_slantr(cham_normtype_t norm, cham_uplo_t uplo, cham_diag_t diag, int M, int N, float *A, int LDA);
int CHAMELEON_slascal(cham_uplo_t uplo, int M, int N, float alpha, float *A, int LDA);
int CHAMELEON_slaset(cham_uplo_t uplo, int M, int N, float alpha, float beta, float *A, int LDA);
//int CHAMELEON_slaswp(int N, float *A, int LDA, int K1, int K2, int *IPIV, int INCX);
//int CHAMELEON_slaswpc(int N, float *A, int LDA, int K1, int K2, int *IPIV, int INCX);
int CHAMELEON_slatms( int M, int N, cham_dist_t idist, unsigned long long int seed, cham_sym_t sym, float *D, int mode, float cond, float dmax, float *A, int LDA );
int CHAMELEON_slauum(cham_uplo_t uplo, int N, float *A, int LDA);
int CHAMELEON_splgsy( float bump, cham_uplo_t uplo, int N, float *A, int LDA, unsigned long long int seed );
int CHAMELEON_splgsy( float bump, cham_uplo_t uplo, int N, float *A, int LDA, unsigned long long int seed );
int CHAMELEON_splrnt( int M, int N, float *A, int LDA, unsigned long long int seed );
int CHAMELEON_splrnk( int M, int N, int K, float *C, int LDC, unsigned long long int seedA, unsigned long long int seedB );
int CHAMELEON_sposv(cham_uplo_t uplo, int N, int NRHS, float *A, int LDA, float *B, int LDB);
int CHAMELEON_spotrf(cham_uplo_t uplo, int N, float *A, int LDA);
int CHAMELEON_ssytrf(cham_uplo_t uplo, int N, float *A, int LDA);
int CHAMELEON_spotri(cham_uplo_t uplo, int N, float *A, int LDA);
int CHAMELEON_spotrimm(cham_uplo_t uplo, int N, float *A, int LDA, float *B, int LDB, float *C, int LDC);
int CHAMELEON_spotrs(cham_uplo_t uplo, int N, int NRHS, float *A, int LDA, float *B, int LDB);
int CHAMELEON_ssymm(cham_side_t side, cham_uplo_t uplo, int M, int N, float alpha, float *A, int LDA, float *B, int LDB, float beta, float *C, int LDC);
int CHAMELEON_ssyrk(cham_uplo_t uplo, cham_trans_t trans, int N, int K, float alpha, float *A, int LDA, float beta, float *C, int LDC);
int CHAMELEON_ssyr2k(cham_uplo_t uplo, cham_trans_t trans, int N, int K, float alpha, float *A, int LDA, float *B, int LDB, float beta, float *C, int LDC);
int CHAMELEON_ssysv(cham_uplo_t uplo, int N, int NRHS, float *A, int LDA, float *B, int LDB);
int CHAMELEON_ssytrs(cham_uplo_t uplo, int N, int NRHS, float *A, int LDA, float *B, int LDB);
int CHAMELEON_stpgqrt( int M, int N, int K, int L, float *V1, int LDV1, CHAM_desc_t *descT1, float *V2, int LDV2, CHAM_desc_t *descT2, float *Q1, int LDQ1, float *Q2, int LDQ2 );
int CHAMELEON_stpqrt( int M, int N, int L, float *A, int LDA, float *B, int LDB, CHAM_desc_t *descT );
int CHAMELEON_stradd(cham_uplo_t uplo, cham_trans_t trans, int M, int N, float alpha, float *A, int LDA, float beta, float *B, int LDB);
int CHAMELEON_strmm(cham_side_t side, cham_uplo_t uplo, cham_trans_t transA, cham_diag_t diag, int N, int NRHS, float alpha, float *A, int LDA, float *B, int LDB);
int CHAMELEON_strsm(cham_side_t side, cham_uplo_t uplo, cham_trans_t transA, cham_diag_t diag, int N, int NRHS, float alpha, float *A, int LDA, float *B, int LDB);
int CHAMELEON_strsmpl(int N, int NRHS, float *A, int LDA, CHAM_desc_t *descL, int *IPIV, float *B, int LDB);
int CHAMELEON_strsmrv(cham_side_t side, cham_uplo_t uplo, cham_trans_t transA, cham_diag_t diag, int N, int NRHS, float alpha, float *A, int LDA, float *B, int LDB);
int CHAMELEON_strtri(cham_uplo_t uplo, cham_diag_t diag, int N, float *A, int LDA);
int CHAMELEON_sorglq(int M, int N, int K, float *A, int LDA, CHAM_desc_t *descT, float *B, int LDB);
int CHAMELEON_sorgqr(int M, int N, int K, float *A, int LDA, CHAM_desc_t *descT, float *B, int LDB);
int CHAMELEON_sormlq(cham_side_t side, cham_trans_t trans, int M, int N, int K, float *A, int LDA, CHAM_desc_t *descT, float *B, int LDB);
int CHAMELEON_sormqr(cham_side_t side, cham_trans_t trans, int M, int N, int K, float *A, int LDA, CHAM_desc_t *descT, float *B, int LDB);

//int CHAMELEON_sgecfi(int m, int n, float *A, CHAMELEON_enum fin, int imb, int inb, CHAMELEON_enum fout, int omb, int onb);
//int CHAMELEON_sgetmi(int m, int n, float *A, CHAMELEON_enum fin, int mb,  int nb);

/**
 *  Declarations of math functions (tile layout) - alphabetical order
 */
int CHAMELEON_sgeadd_Tile(cham_trans_t trans, float alpha, CHAM_desc_t *A, float beta, CHAM_desc_t *B);
//int CHAMELEON_sgebrd_Tile(CHAM_desc_t *A, float *D, float *E, CHAM_desc_t *T);
//int CHAMELEON_sgecon_Tile(cham_normtype_t norm, CHAM_desc_t *A, float anorm, float *rcond);
//int CHAMELEON_spocon_Tile(cham_uplo_t uplo, CHAM_desc_t *A, float anorm, float *rcond);
int CHAMELEON_sgelqf_Tile(CHAM_desc_t *A, CHAM_desc_t *T);
int CHAMELEON_sgelqs_Tile(CHAM_desc_t *A, CHAM_desc_t *T, CHAM_desc_t *B);
int CHAMELEON_sgels_Tile(cham_trans_t trans, CHAM_desc_t *A, CHAM_desc_t *T, CHAM_desc_t *B);
float CHAMELEON_sgenm2_Tile( float tol, CHAM_desc_t *A );
int CHAMELEON_sgemm_Tile(cham_trans_t transA, cham_trans_t transB, float alpha, CHAM_desc_t *A, CHAM_desc_t *B, float beta, CHAM_desc_t *C);
int CHAMELEON_sgepdf_qdwh_Tile( CHAM_desc_t *A, CHAM_desc_t *H, gepdf_info_t *info );
int CHAMELEON_sgepdf_qr_Tile( int doqr, int optid, const libhqr_tree_t *qrtreeT, const libhqr_tree_t *qrtreeB, CHAM_desc_t *A1, CHAM_desc_t *TS1, CHAM_desc_t *TT1, CHAM_desc_t *Q1, CHAM_desc_t *A2, CHAM_desc_t *TS2, CHAM_desc_t *TT2, CHAM_desc_t *Q2 );
int CHAMELEON_sgeqrf_Tile(CHAM_desc_t *A, CHAM_desc_t *T);
int CHAMELEON_sgeqrs_Tile(CHAM_desc_t *A, CHAM_desc_t *T, CHAM_desc_t *B);
//int CHAMELEON_sgesv_Tile(CHAM_desc_t *A, int *IPIV, CHAM_desc_t *B);
int CHAMELEON_sgesv_incpiv_Tile(CHAM_desc_t *A, CHAM_desc_t *L, int *IPIV, CHAM_desc_t *B);
int CHAMELEON_sgesv_nopiv_Tile(CHAM_desc_t *A, CHAM_desc_t *B);
int CHAMELEON_sgesvd_Tile(cham_job_t jobu, cham_job_t jobvt, CHAM_desc_t *A, float *S, CHAM_desc_t *T, float *U, int LDU, float *VT, int LDVT);
//int CHAMELEON_sgetrf_Tile(CHAM_desc_t *A, int *IPIV);
int CHAMELEON_sgetrf_incpiv_Tile(CHAM_desc_t *A, CHAM_desc_t *L, int *IPIV);
int CHAMELEON_sgetrf_nopiv_Tile(CHAM_desc_t *A);
//int CHAMELEON_sgetri_Tile(CHAM_desc_t *A, int *IPIV);
//int CHAMELEON_sgetrs_Tile(cham_trans_t trans, CHAM_desc_t *A, int *IPIV, CHAM_desc_t *B);
int CHAMELEON_sgetrs_incpiv_Tile(CHAM_desc_t *A, CHAM_desc_t *L, int *IPIV, CHAM_desc_t *B);
int CHAMELEON_sgetrs_nopiv_Tile(CHAM_desc_t *A, CHAM_desc_t *B);
int CHAMELEON_ssymm_Tile(cham_side_t side, cham_uplo_t uplo, float alpha, CHAM_desc_t *A, CHAM_desc_t *B, float beta, CHAM_desc_t *C);
int CHAMELEON_ssyrk_Tile(cham_uplo_t uplo, cham_trans_t trans, float alpha, CHAM_desc_t *A, float beta, CHAM_desc_t *C);
int CHAMELEON_ssyr2k_Tile(cham_uplo_t uplo, cham_trans_t trans, float alpha, CHAM_desc_t *A, CHAM_desc_t *B, float beta, CHAM_desc_t *C);
//int CHAMELEON_ssyev_Tile(cham_job_t jobz, cham_uplo_t uplo, CHAM_desc_t *A, float *W, CHAM_desc_t *T, float *Q, int LDQ);
int CHAMELEON_ssyevd_Tile(cham_job_t jobz, cham_uplo_t uplo, CHAM_desc_t *A, float *W, CHAM_desc_t *T);
//int CHAMELEON_ssygv_Tile( CHAMELEON_enum itype, cham_job_t jobz, cham_uplo_t uplo, CHAM_desc_t *A, CHAM_desc_t *B, float *W, CHAM_desc_t *T, CHAM_desc_t *Q);
//int CHAMELEON_ssygvd_Tile(CHAMELEON_enum itype, cham_job_t jobz, cham_uplo_t uplo, CHAM_desc_t *A, CHAM_desc_t *B, float *W, CHAM_desc_t *T, CHAM_desc_t *Q);
//int CHAMELEON_ssygst_Tile(CHAMELEON_enum itype, cham_uplo_t uplo, CHAM_desc_t *A, CHAM_desc_t *B);
int CHAMELEON_ssytrd_Tile(cham_job_t jobz, cham_uplo_t uplo, CHAM_desc_t *A, float *D, float *E, CHAM_desc_t *T, float *Q, int LDQ);
int CHAMELEON_slacpy_Tile(cham_uplo_t uplo, CHAM_desc_t *A, CHAM_desc_t *B);
float CHAMELEON_slange_Tile(cham_normtype_t norm, CHAM_desc_t *A);
float CHAMELEON_slansy_Tile(cham_normtype_t norm, cham_uplo_t uplo, CHAM_desc_t *A);
float CHAMELEON_slansy_Tile(cham_normtype_t norm, cham_uplo_t uplo, CHAM_desc_t *A);
float CHAMELEON_slantr_Tile(cham_normtype_t norm, cham_uplo_t uplo, cham_diag_t diag, CHAM_desc_t *A);
int CHAMELEON_slascal_Tile(cham_uplo_t uplo, float alpha, CHAM_desc_t *A);
int CHAMELEON_slaset_Tile(cham_uplo_t uplo, float alpha, float beta, CHAM_desc_t *A);
//int CHAMELEON_slaswp_Tile(CHAM_desc_t *A, int K1, int K2, int *IPIV, int INCX);
//int CHAMELEON_slaswpc_Tile(CHAM_desc_t *A, int K1, int K2, int *IPIV, int INCX);
int CHAMELEON_slatms_Tile( cham_dist_t idist, unsigned long long int seed, cham_sym_t sym, float *D, int mode, float cond, float dmax, CHAM_desc_t *A );
int CHAMELEON_slauum_Tile(cham_uplo_t uplo, CHAM_desc_t *A);
int CHAMELEON_splgsy_Tile(float bump, cham_uplo_t uplo, CHAM_desc_t *A, unsigned long long int seed );
int CHAMELEON_splgsy_Tile(float bump, cham_uplo_t uplo, CHAM_desc_t *A, unsigned long long int seed );
int CHAMELEON_splrnt_Tile(CHAM_desc_t *A, unsigned long long int seed );
int CHAMELEON_splrnk_Tile(int K, CHAM_desc_t *C, unsigned long long int seedA, unsigned long long int seedB );
int CHAMELEON_sposv_Tile(cham_uplo_t uplo, CHAM_desc_t *A, CHAM_desc_t *B);
int CHAMELEON_spotrf_Tile(cham_uplo_t uplo, CHAM_desc_t *A);
int CHAMELEON_ssytrf_Tile(cham_uplo_t uplo, CHAM_desc_t *A);
int CHAMELEON_spotri_Tile(cham_uplo_t uplo, CHAM_desc_t *A);
int CHAMELEON_spotrimm_Tile(cham_uplo_t uplo, CHAM_desc_t *A, CHAM_desc_t *B, CHAM_desc_t *C);
int CHAMELEON_spotrs_Tile(cham_uplo_t uplo, CHAM_desc_t *A, CHAM_desc_t *B);
int CHAMELEON_ssymm_Tile(cham_side_t side, cham_uplo_t uplo, float alpha, CHAM_desc_t *A, CHAM_desc_t *B, float beta, CHAM_desc_t *C);
int CHAMELEON_ssyrk_Tile(cham_uplo_t uplo, cham_trans_t trans, float alpha, CHAM_desc_t *A, float beta, CHAM_desc_t *C);
int CHAMELEON_ssyr2k_Tile(cham_uplo_t uplo, cham_trans_t trans, float alpha, CHAM_desc_t *A, CHAM_desc_t *B, float beta, CHAM_desc_t *C);
int CHAMELEON_ssysv_Tile(cham_uplo_t uplo, CHAM_desc_t *A, CHAM_desc_t *B);
int CHAMELEON_ssytrs_Tile(cham_uplo_t uplo, CHAM_desc_t *A, CHAM_desc_t *B);
int CHAMELEON_stpgqrt_Tile( int L, CHAM_desc_t *V1, CHAM_desc_t *T1, CHAM_desc_t *V2, CHAM_desc_t *T2, CHAM_desc_t *Q1, CHAM_desc_t *Q2 );
int CHAMELEON_stpqrt_Tile( int L, CHAM_desc_t *A, CHAM_desc_t *B, CHAM_desc_t *T );
int CHAMELEON_stradd_Tile(cham_uplo_t uplo, cham_trans_t trans, float alpha, CHAM_desc_t *A, float beta, CHAM_desc_t *B);
int CHAMELEON_strmm_Tile(cham_side_t side, cham_uplo_t uplo, cham_trans_t transA, cham_diag_t diag, float alpha, CHAM_desc_t *A, CHAM_desc_t *B);
int CHAMELEON_strsm_Tile(cham_side_t side, cham_uplo_t uplo, cham_trans_t transA, cham_diag_t diag, float alpha, CHAM_desc_t *A, CHAM_desc_t *B);
int CHAMELEON_strsmpl_Tile(CHAM_desc_t *A, CHAM_desc_t *L, int *IPIV, CHAM_desc_t *B);
int CHAMELEON_strsmrv_Tile(cham_side_t side, cham_uplo_t uplo, cham_trans_t transA, cham_diag_t diag, float alpha, CHAM_desc_t *A, CHAM_desc_t *B);
int CHAMELEON_strtri_Tile(cham_uplo_t uplo, cham_diag_t diag, CHAM_desc_t *A);
int CHAMELEON_sorglq_Tile(CHAM_desc_t *A, CHAM_desc_t *T, CHAM_desc_t *B);
int CHAMELEON_sorgqr_Tile(CHAM_desc_t *A, CHAM_desc_t *T, CHAM_desc_t *B);
int CHAMELEON_sormlq_Tile(cham_side_t side, cham_trans_t trans, CHAM_desc_t *A, CHAM_desc_t *T, CHAM_desc_t *B);
int CHAMELEON_sormqr_Tile(cham_side_t side, cham_trans_t trans, CHAM_desc_t *A, CHAM_desc_t *T, CHAM_desc_t *B);

/**
 *  Declarations of math functions (tile layout, asynchronous execution) - alphabetical order
 */
int CHAMELEON_sgeadd_Tile_Async(cham_trans_t trans, float alpha, CHAM_desc_t *A, float beta, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
//int CHAMELEON_sgebrd_Tile_Async(CHAM_desc_t *A, float *D, float *E, CHAM_desc_t *T, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
//int CHAMELEON_sgecon_Tile_Async(cham_normtype_t norm, CHAM_desc_t *A, float anorm, float *rcond, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
//int CHAMELEON_spocon_Tile_Async(cham_uplo_t uplo, CHAM_desc_t *A, float anorm, float *rcond, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_sgelqf_Tile_Async(CHAM_desc_t *A, CHAM_desc_t *T, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_sgelqs_Tile_Async(CHAM_desc_t *A, CHAM_desc_t *T, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_sgels_Tile_Async(cham_trans_t trans, CHAM_desc_t *A, CHAM_desc_t *T, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_sgenm2_Tile_Async( float tol, CHAM_desc_t *A, float *value, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request );
int CHAMELEON_sgemm_Tile_Async(cham_trans_t transA, cham_trans_t transB, float alpha, CHAM_desc_t *A, CHAM_desc_t *B, float beta, CHAM_desc_t *C, void *ws, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_sgepdf_qdwh_Tile_Async( CHAM_desc_t *A, CHAM_desc_t *H, gepdf_info_t *info, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request );
int CHAMELEON_sgeqrf_Tile_Async(CHAM_desc_t *A, CHAM_desc_t *T, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_sgeqrs_Tile_Async(CHAM_desc_t *A, CHAM_desc_t *T, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
//int CHAMELEON_sgesv_Tile_Async(CHAM_desc_t *A, int *IPIV, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_sgesv_incpiv_Tile_Async(CHAM_desc_t *A, CHAM_desc_t *L, int *IPIV, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_sgesv_nopiv_Tile_Async(CHAM_desc_t *A, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_sgesvd_Tile_Async(cham_job_t jobu, cham_job_t jobvt, CHAM_desc_t *A, float *S, CHAM_desc_t *T, float *U, int LDU, float *VT, int LDVT, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
//int CHAMELEON_sgetrf_Tile_Async(CHAM_desc_t *A, int *IPIV, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_sgetrf_incpiv_Tile_Async(CHAM_desc_t *A, CHAM_desc_t *L, int *IPIV, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_sgetrf_nopiv_Tile_Async(CHAM_desc_t *A, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
//int CHAMELEON_sgetri_Tile_Async(CHAM_desc_t *A, int *IPIV, CHAM_desc_t *W, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
//int CHAMELEON_sgetrs_Tile_Async(cham_trans_t trans, CHAM_desc_t *A, int *IPIV, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_sgetrs_incpiv_Tile_Async(CHAM_desc_t *A, CHAM_desc_t *L, int *IPIV, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_sgetrs_nopiv_Tile_Async(CHAM_desc_t *A, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_ssymm_Tile_Async(cham_side_t side, cham_uplo_t uplo, float alpha, CHAM_desc_t *A, CHAM_desc_t *B, float beta, CHAM_desc_t *C, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_ssyrk_Tile_Async(cham_uplo_t uplo, cham_trans_t trans, float alpha, CHAM_desc_t *A, float beta, CHAM_desc_t *C, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_ssyr2k_Tile_Async(cham_uplo_t uplo, cham_trans_t trans, float alpha, CHAM_desc_t *A, CHAM_desc_t *B, float beta, CHAM_desc_t *C, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
//int CHAMELEON_ssyev_Tile_Async(cham_job_t jobz, cham_uplo_t uplo, CHAM_desc_t *A, float *W, CHAM_desc_t *T, float *Q, int LDQ, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_ssyevd_Tile_Async(cham_job_t jobz, cham_uplo_t uplo, CHAM_desc_t *A, float *W, CHAM_desc_t *T, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
//int CHAMELEON_ssygv_Tile_Async( CHAMELEON_enum itype, cham_job_t jobz, cham_uplo_t uplo, CHAM_desc_t *A, CHAM_desc_t *B, float *W, CHAM_desc_t *T, CHAM_desc_t *Q, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
//int CHAMELEON_ssygvd_Tile_Async(CHAMELEON_enum itype, cham_job_t jobz, cham_uplo_t uplo, CHAM_desc_t *A, CHAM_desc_t *B, float *W, CHAM_desc_t *T, CHAM_desc_t *Q, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
//int CHAMELEON_ssygst_Tile_Async(CHAMELEON_enum itype, cham_uplo_t uplo, CHAM_desc_t *A, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_ssytrd_Tile_Async(cham_job_t jobz, cham_uplo_t uplo, CHAM_desc_t *A, float *D, float *E, CHAM_desc_t *T, float *Q, int LDQ, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_slacpy_Tile_Async(cham_uplo_t uplo, CHAM_desc_t *A, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_slange_Tile_Async(cham_normtype_t norm, CHAM_desc_t *A, float *value, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_slansy_Tile_Async(cham_normtype_t norm, cham_uplo_t uplo, CHAM_desc_t *A, float *value, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_slansy_Tile_Async(cham_normtype_t norm, cham_uplo_t uplo, CHAM_desc_t *A, float *value, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_slantr_Tile_Async(cham_normtype_t norm, cham_uplo_t uplo, cham_diag_t diag, CHAM_desc_t *A, float *value, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_slascal_Tile_Async(cham_uplo_t uplo, float alpha, CHAM_desc_t *A, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_slaset_Tile_Async(cham_uplo_t uplo, float alpha, float beta, CHAM_desc_t *A, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
//int CHAMELEON_slaswp_Tile_Async(CHAM_desc_t *A, int K1, int K2, int *IPIV, int INCX, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
//int CHAMELEON_slaswpc_Tile_Async(CHAM_desc_t *A, int K1, int K2, int *IPIV, int INCX, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_slatms_Tile_Async( cham_dist_t idist, unsigned long long int seed, cham_sym_t sym, float *D, int mode, float cond, float dmax, CHAM_desc_t *A, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request );
int CHAMELEON_slauum_Tile_Async(cham_uplo_t uplo, CHAM_desc_t *A, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_splgsy_Tile_Async(float bump, cham_uplo_t uplo, CHAM_desc_t *A, unsigned long long int seed, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request );
int CHAMELEON_splgsy_Tile_Async(float bump, cham_uplo_t uplo, CHAM_desc_t *A, unsigned long long int seed, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request );
int CHAMELEON_splrnt_Tile_Async(CHAM_desc_t *A, unsigned long long int seed, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request );
int CHAMELEON_splrnk_Tile_Async(int K, CHAM_desc_t *C, unsigned long long int seedA, unsigned long long int seedB, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request );
int CHAMELEON_sposv_Tile_Async(cham_uplo_t uplo, CHAM_desc_t *A, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_spotrf_Tile_Async(cham_uplo_t uplo, CHAM_desc_t *A, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_ssytrf_Tile_Async(cham_uplo_t uplo, CHAM_desc_t *A, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_spotri_Tile_Async(cham_uplo_t uplo, CHAM_desc_t *A, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_spotrimm_Tile_Async(cham_uplo_t uplo, CHAM_desc_t *A, CHAM_desc_t *B, CHAM_desc_t *C, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_spotrs_Tile_Async(cham_uplo_t uplo, CHAM_desc_t *A, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_ssysv_Tile_Async(cham_uplo_t uplo, CHAM_desc_t *A, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_ssytrs_Tile_Async(cham_uplo_t uplo, CHAM_desc_t *A, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_ssymm_Tile_Async(cham_side_t side, cham_uplo_t uplo, float alpha, CHAM_desc_t *A, CHAM_desc_t *B, float beta, CHAM_desc_t *C, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_ssyrk_Tile_Async(cham_uplo_t uplo, cham_trans_t trans, float alpha, CHAM_desc_t *A, float beta, CHAM_desc_t *C, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_ssyr2k_Tile_Async(cham_uplo_t uplo, cham_trans_t trans, float alpha, CHAM_desc_t *A, CHAM_desc_t *B, float beta, CHAM_desc_t *C, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_stpgqrt_Tile_Async( int L, CHAM_desc_t *V1, CHAM_desc_t *T1, CHAM_desc_t *V2, CHAM_desc_t *T2, CHAM_desc_t *Q1, CHAM_desc_t *Q2, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request );
int CHAMELEON_stpqrt_Tile_Async( int L, CHAM_desc_t *A, CHAM_desc_t *B, CHAM_desc_t *T, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request );
int CHAMELEON_stradd_Tile_Async(cham_uplo_t uplo, cham_trans_t trans, float alpha, CHAM_desc_t *A, float beta, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_strmm_Tile_Async(cham_side_t side, cham_uplo_t uplo, cham_trans_t transA, cham_diag_t diag, float alpha, CHAM_desc_t *A, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_strsm_Tile_Async(cham_side_t side, cham_uplo_t uplo, cham_trans_t transA, cham_diag_t diag, float alpha, CHAM_desc_t *A, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_strsmpl_Tile_Async(CHAM_desc_t *A, CHAM_desc_t *L, int *IPIV, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_strsmrv_Tile_Async(cham_side_t side, cham_uplo_t uplo, cham_trans_t transA, cham_diag_t diag, float alpha, CHAM_desc_t *A, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_strtri_Tile_Async(cham_uplo_t uplo, cham_diag_t diag, CHAM_desc_t *A, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_sorglq_Tile_Async(CHAM_desc_t *A, CHAM_desc_t *T, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_sorgqr_Tile_Async(CHAM_desc_t *A, CHAM_desc_t *T, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_sormlq_Tile_Async(cham_side_t side, cham_trans_t trans, CHAM_desc_t *A, CHAM_desc_t *T, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_sormqr_Tile_Async(cham_side_t side, cham_trans_t trans, CHAM_desc_t *A, CHAM_desc_t *T, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);

//int CHAMELEON_sgecfi_Async(int m, int n, float *A, CHAMELEON_enum f_in, int imb, int inb, CHAMELEON_enum f_out, int omb, int onb, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
//int CHAMELEON_sgetmi_Async(int m, int n, float *A, CHAMELEON_enum f_in, int mb,  int inb, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);

/**
 *  Declarations of libhqr dependent functions.
 */
/**
 *  Declarations of math functions (LAPACK layout) - alphabetical order
 */
int CHAMELEON_sgels_param(const libhqr_tree_t *qrtree, cham_trans_t trans, int M, int N, int NRHS, float *A, int LDA, CHAM_desc_t *descTS, CHAM_desc_t *descTT, float *B, int LDB);
int CHAMELEON_sgelqf_param(const libhqr_tree_t *qrtree, int M, int N, float *A, int LDA, CHAM_desc_t *descTS, CHAM_desc_t *descTT);
int CHAMELEON_sgelqs_param(const libhqr_tree_t *qrtree, int M, int N, int NRHS, float *A, int LDA, CHAM_desc_t *descTS, CHAM_desc_t *descTT, float *B, int LDB);
int CHAMELEON_sgeqrf_param(const libhqr_tree_t *qrtree, int M, int N, float *A, int LDA, CHAM_desc_t *descTS, CHAM_desc_t *descTT);
int CHAMELEON_sgeqrs_param(const libhqr_tree_t *qrtree, int M, int N, int NRHS, float *A, int LDA, CHAM_desc_t *descTS, CHAM_desc_t *TT, float *B, int LDB);
int CHAMELEON_sorglq_param(const libhqr_tree_t *qrtree, int M, int N, int K, float *A, int LDA, CHAM_desc_t *descTS, CHAM_desc_t *TT, float *B, int LDB);
int CHAMELEON_sorgqr_param(const libhqr_tree_t *qrtree, int M, int N, int K, float *A, int LDA, CHAM_desc_t *descTS, CHAM_desc_t *descTT, float *B, int LDB);
int CHAMELEON_sormlq_param(const libhqr_tree_t *qrtree, cham_side_t side, cham_trans_t trans, int M, int N, int K, float *A, int LDA, CHAM_desc_t *descT, CHAM_desc_t *TT, float *B, int LDB);
int CHAMELEON_sormlq_param(const libhqr_tree_t *qrtree, cham_side_t side, cham_trans_t trans, int M, int N, int K, float *A, int LDA, CHAM_desc_t *descT, CHAM_desc_t *TT, float *B, int LDB);
int CHAMELEON_sormqr_param(const libhqr_tree_t *qrtree, cham_side_t side, cham_trans_t trans, int M, int N, int K, float *A, int LDA, CHAM_desc_t *descTS, CHAM_desc_t *TT, float *B, int LDB);
/**
 *  Declarations of math functions (tile layout) - alphabetical order
 */
int CHAMELEON_sgels_param_Tile(const libhqr_tree_t *qrtree, cham_trans_t trans, CHAM_desc_t *A, CHAM_desc_t *TS, CHAM_desc_t *TT, CHAM_desc_t *B);
int CHAMELEON_sgelqf_param_Tile(const libhqr_tree_t *qrtree, CHAM_desc_t *A, CHAM_desc_t *TS, CHAM_desc_t *TT);
int CHAMELEON_sgelqs_param_Tile(const libhqr_tree_t *qrtree, CHAM_desc_t *A, CHAM_desc_t *TS, CHAM_desc_t *TT, CHAM_desc_t *B);
int CHAMELEON_sgeqrf_param_Tile(const libhqr_tree_t *qrtree, CHAM_desc_t *A, CHAM_desc_t *TS, CHAM_desc_t *TT);
int CHAMELEON_sgeqrs_param_Tile(const libhqr_tree_t *qrtree, CHAM_desc_t *A, CHAM_desc_t *TS, CHAM_desc_t *TT, CHAM_desc_t *B);
int CHAMELEON_sorglq_param_Tile(const libhqr_tree_t *qrtree, CHAM_desc_t *A, CHAM_desc_t *TS, CHAM_desc_t *TT, CHAM_desc_t *B);
int CHAMELEON_sorgqr_param_Tile(const libhqr_tree_t *qrtree, CHAM_desc_t *A, CHAM_desc_t *TS, CHAM_desc_t *TT, CHAM_desc_t *B);
int CHAMELEON_sorgqr_param_Tile(const libhqr_tree_t *qrtree, CHAM_desc_t *A, CHAM_desc_t *TS, CHAM_desc_t *TT, CHAM_desc_t *B);
int CHAMELEON_sormlq_param_Tile(const libhqr_tree_t *qrtree, cham_side_t side, cham_trans_t trans, CHAM_desc_t *A, CHAM_desc_t *TS, CHAM_desc_t *TT, CHAM_desc_t *B);
int CHAMELEON_sormqr_param_Tile(const libhqr_tree_t *qrtree, cham_side_t side, cham_trans_t trans, CHAM_desc_t *A, CHAM_desc_t *TS, CHAM_desc_t *TT, CHAM_desc_t *B);
/**
 *  Declarations of math functions (tile layout, asynchronous execution) - alphabetical order
 */
int CHAMELEON_sgels_param_Tile_Async(const libhqr_tree_t *qrtree, cham_trans_t trans, CHAM_desc_t *A, CHAM_desc_t *TS, CHAM_desc_t *TT, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_sgelqf_param_Tile_Async(const libhqr_tree_t *qrtree, CHAM_desc_t *A, CHAM_desc_t *TS, CHAM_desc_t *TT, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_sgelqs_param_Tile_Async(const libhqr_tree_t *qrtree, CHAM_desc_t *A, CHAM_desc_t *TS, CHAM_desc_t *TT, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_sgeqrf_param_Tile_Async(const libhqr_tree_t *qrtree, CHAM_desc_t *A, CHAM_desc_t *TS, CHAM_desc_t *TT, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_sgeqrs_param_Tile_Async(const libhqr_tree_t *qrtree, CHAM_desc_t *A, CHAM_desc_t *TS, CHAM_desc_t *TT, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_sorglq_param_Tile_Async(const libhqr_tree_t *qrtree, CHAM_desc_t *A, CHAM_desc_t *TS, CHAM_desc_t *TT, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_sorgqr_param_Tile_Async(const libhqr_tree_t *qrtree, CHAM_desc_t *A, CHAM_desc_t *TS, CHAM_desc_t *TT, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_sormlq_param_Tile_Async(const libhqr_tree_t *qrtree, cham_side_t side, cham_trans_t trans, CHAM_desc_t *A, CHAM_desc_t *TS, CHAM_desc_t *TT, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);
int CHAMELEON_sormqr_param_Tile_Async(const libhqr_tree_t *qrtree, cham_side_t side, cham_trans_t trans, CHAM_desc_t *A, CHAM_desc_t *TS, CHAM_desc_t *TT, CHAM_desc_t *B, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request);

/**
 *  Declarations of workspace allocation functions (tile layout) - alphabetical order
 */
void *CHAMELEON_sgemm_WS_Alloc( cham_trans_t transA, cham_trans_t transB, const CHAM_desc_t *A, const CHAM_desc_t *B, const CHAM_desc_t *C );
void  CHAMELEON_sgemm_WS_Free( void *ws );
void *CHAMELEON_sgram_WS_Alloc( const CHAM_desc_t *A );
void  CHAMELEON_sgram_WS_Free( void *ws );

int CHAMELEON_Alloc_Workspace_sgesv_incpiv(        int N, CHAM_desc_t **descL, int **IPIV, int p, int q);
int CHAMELEON_Alloc_Workspace_sgetrf_incpiv(int M, int N, CHAM_desc_t **descL, int **IPIV, int p, int q);

int CHAMELEON_Alloc_Workspace_sgebrd(int M, int N, CHAM_desc_t **descT, int p, int q);
int CHAMELEON_Alloc_Workspace_sgeev( int N,        CHAM_desc_t **descT, int p, int q);
int CHAMELEON_Alloc_Workspace_sgehrd(int N,        CHAM_desc_t **descT, int p, int q);
int CHAMELEON_Alloc_Workspace_sgelqf(int M, int N, CHAM_desc_t **T, int p, int q);
int CHAMELEON_Alloc_Workspace_sgels( int M, int N, CHAM_desc_t **T, int p, int q);
int CHAMELEON_Alloc_Workspace_sgeqrf(int M, int N, CHAM_desc_t **T, int p, int q);
int CHAMELEON_Alloc_Workspace_sgesvd(int M, int N, CHAM_desc_t **descT, int p, int q);
int CHAMELEON_Alloc_Workspace_ssyev( int M, int N, CHAM_desc_t **descT, int p, int q);
int CHAMELEON_Alloc_Workspace_ssyevd( int M, int N, CHAM_desc_t **descT, int p, int q);
int CHAMELEON_Alloc_Workspace_ssygv( int M, int N, CHAM_desc_t **descT, int p, int q);
int CHAMELEON_Alloc_Workspace_ssygvd( int M, int N, CHAM_desc_t **descT, int p, int q);
int CHAMELEON_Alloc_Workspace_ssytrd(int M, int N, CHAM_desc_t **descT, int p, int q);

/**
 *  Declarations of workspace allocation functions (tile layout, asynchronous execution) - alphabetical order
 */
int CHAMELEON_Alloc_Workspace_sgetri_Tile_Async(CHAM_desc_t *A, CHAM_desc_t *W);

/* Warning: Those functions are deprecated */
int CHAMELEON_Alloc_Workspace_sgelqf_Tile(int M, int N, CHAM_desc_t **descT, int p, int q);
int CHAMELEON_Alloc_Workspace_sgels_Tile( int M, int N, CHAM_desc_t **descT, int p, int q);
int CHAMELEON_Alloc_Workspace_sgeqrf_Tile(int M, int N, CHAM_desc_t **descT, int p, int q);
int CHAMELEON_Alloc_Workspace_sgesv_incpiv_Tile (int N, CHAM_desc_t **descL, int **IPIV, int p, int q);
int CHAMELEON_Alloc_Workspace_sgetrf_incpiv_Tile(int N, CHAM_desc_t **descL, int **IPIV, int p, int q);

/**
 *  Auxiliary function prototypes
 */
int CHAMELEON_sLapack_to_Tile( float *Af77, int LDA, CHAM_desc_t *A ) __attribute__((deprecated("Please refer to CHAMELEON_sLap2Desc() instead")));
int CHAMELEON_sTile_to_Lapack( CHAM_desc_t *A, float *Af77, int LDA ) __attribute__((deprecated("Please refer to CHAMELEON_sDesc2Lap() instead")));
int CHAMELEON_sLap2Desc( cham_uplo_t uplo, float *Af77, int LDA, CHAM_desc_t *A );
int CHAMELEON_sDesc2Lap( cham_uplo_t uplo, CHAM_desc_t *A, float *Af77, int LDA );

/**
 *  User Builder function prototypes
 */
int CHAMELEON_sbuild(cham_uplo_t uplo, int M, int N, float *A, int LDA, void *user_data, void* user_build_callback);
int CHAMELEON_sbuild_Tile(cham_uplo_t uplo,  CHAM_desc_t *A, void *user_data, void* user_build_callback );
int CHAMELEON_sbuild_Tile_Async(cham_uplo_t uplo, CHAM_desc_t *A, void *user_data, void* user_build_callback, RUNTIME_sequence_t *sequence, RUNTIME_request_t  *request);

/**
 * Gram function prototypes
 */
int CHAMELEON_sgram( cham_uplo_t uplo, int N, float *A, int LDA );
int CHAMELEON_sgram_Tile( cham_uplo_t uplo, CHAM_desc_t *A );
int CHAMELEON_sgram_Tile_Async( cham_uplo_t uplo, CHAM_desc_t *A, void *user_ws, RUNTIME_sequence_t *sequence, RUNTIME_request_t *request );

END_C_DECLS

#endif /* _chameleon_s_h_ */
