/**
 *
 * @file chameleon_tasks_ds.h
 *
 * @copyright 2009-2014 The University of Tennessee and The University of
 *                      Tennessee Research Foundation. All rights reserved.
 * @copyright 2012-2021 Bordeaux INP, CNRS (LaBRI UMR 5800), Inria,
 *                      Univ. Bordeaux. All rights reserved.
 *
 ***
 *
 * @brief Chameleon real mixed precision elementary tasks header
 *
 * @version 1.0.0
 * @comment This file has been automatically generated
 *          from Plasma 2.5.0 for CHAMELEON 0.9.2
 * @author Jakub Kurzak
 * @author Hatem Ltaief
 * @author Mathieu Faverge
 * @author Emmanuel Agullo
 * @author Cedric Castagnede
 * @author Florent Pruvost
 * @date 2020-03-03
 * @generated from /tmp/SBo/slackrepo.hYhfkL/build_chameleon/chameleon-1.1.0/include/chameleon/tasks_zc.h, mixed zc -> ds, Fri Feb  2 00:25:22 2024
 *
 */
#ifndef _chameleon_tasks_ds_h_
#define _chameleon_tasks_ds_h_

/**
 *  Declarations of QUARK wrappers (called by CHAMELEON) - alphabetical order
 */
void INSERT_TASK_slag2d( const RUNTIME_option_t *options,
                        int m, int n, int nb,
                        CHAM_desc_t *A, int Am, int An, int lda,
                        CHAM_desc_t *B, int Bm, int Bn, int ldb );
void INSERT_TASK_dlag2s( const RUNTIME_option_t *options,
                        int m, int n, int nb,
                        CHAM_desc_t *A, int Am, int An, int lda,
                        CHAM_desc_t *B, int Bm, int Bn, int ldb );

#endif /* _chameleon_tasks_ds_h_ */
